
REVISION -genmac "--- 1.0D general macro's : DS+, DS-, DD+ ---"


\ #################### general ###########################################

FWORD Temp      \ General purpose, must be temporary.
0 VALUE II      \ inner loop variable
FWORD DownLim   \ inner loop limits
FWORD UpLim

\ Store register B (l.s.) and A (m.s.) in W (big-endian)
\ tested
MACRO dstl,    ( fword W -- )
    DUP 1+ stl, stl,
END-MACRO

\ Load register B (l.s.) and A (m.s.) from W (big-endian)
\ tested
MACRO dldl,    ( fword W -- )
    DUP ldl, 1+ ldl,
END-MACRO

\ Leave the minimum of X and Y in register A
\ half tested ( still with both orderS)
\ code generated inspected, this MUST work
MACRO min,      ( fword X fword Y )
    2DUP >S >S ldl, ldl, >, IF,
       S> ldl, Temp stl,
    ELSE,
       S> ldl, Temp stl,
    ENDIF,
    Temp ldl,
END-MACRO

\ Leave the maximum of X and Y in register A
\ half tested ( still with both orderS)
\ code generated inspected, this MUST work
MACRO max,      ( fword X fword Y )
    OVER >S DUP >S ldl, ldl, >, IF,
       S> ldl, Temp stl,
    ELSE,
       S> ldl, Temp stl,
    ENDIF,
    Temp ldl,
END-MACRO

\ Leave the absolute value of register A in register A
\ tested
\ code generated inspected, this MUST work
MACRO abs,      ( reg A - reg A)
    Temp stl, Temp ldl, 0<, IF,
       0 ldc, Temp ldl, sub, Temp stl,
    ENDIF,
    Temp ldl,
END-MACRO

\ Leave the negative value of register A in register A
\ tested
MACRO neg,      ( reg A - reg A)
    not, 1 adc,
END-MACRO

VARIABLE MY-HERE
\ Never used so commented out
\ FROM .. END-FROM counts down using II
\ Executed for the upper limit in reg A down to and including zero
\ So A+1 times.
\ tested in combination with END-FROM where no values in internal
\ registers were to be saved
\ MACRO FROM      ( upper limit in reg A -- )
\     DownLim TO II
\     II stl,
\     HERE  MY-HERE !
\ END-MACRO
\
\ MACRO END-FROM
\         II ldl, -1 adc, dup, II stl, -1 eqc,
\     MY-HERE @  cj,                         \ Consume HERE
\ END-MACRO

\ Expect lower limit in A upper limits in B, these limits are inclusive
\ tested
MACRO UPDO,
      DownLim TO II     \ Remember where the loop counter is
      DownLim stl, UpLim stl,
      BEGIN,
          UpLim ldl,   II ldl,   >=, WHILE,
END-MACRO

\ Expect upper limits in A, lower limit is 0, these limits are inclusive
\ Works for A<=0 too.
\ tested
MACRO DOWNTO0,
      UpLim TO II     \ Remember where the loop counter is
      UpLim stl,
      BEGIN,
          II ldl,   0>=, WHILE,
END-MACRO

\ Expects increment ( int i -- ) that is a compile time constant
\ tested
MACRO FIXED+LOOP,
    II ldl,   ( stack) adc,   II stl,
    REPEAT,
END-MACRO

\ Expects increment ( reg A -- ) that is calculated at run time
MACRO +LOOP,
    II ldl,   add, II stl,
    REPEAT,
END-MACRO

\ Expects decrement ( reg A -- ) that is calculated at run time
\ tested hoezo tested????
MACRO -LOOP,
    II ldl, rev, sub, II stl,
    REPEAT,
END-MACRO

\ #################### calculation macro's ###########################################

\ Add the double number D from the workspace to the number S from the
\ workspace and leave the result in A,B. A is m.s.
\ The result can be used by dstl,
\ tested also overflow
MACRO DS+,       ( double D single S -- ) ( -- reg A, reg B )
    0 ldc,
    ldl, DUP ldl, lsum,         ( -- A l.s. , B m.s. )
    rev,
    1+ ldl,   sum,         \ Add to m.s. word, expecting no overflow
END-MACRO

\ Add the double numbers at T1 and T2 and put the result in S.
MACRO DD+,       ( double T1 double T2 double S -- ) ( -- )
    LOCAL S LOCAL T2 LOCAL T1
    0 ldc,   T1 ldl,   T2 ldl,   lsum,    S stl,        ( -- A carry )
    ( A)   T1 1+ ldl,   T2 1+ ldl,   ladd,   S 1+ stl,
END-MACRO

\ Subtract from the double number D from the workspace, the number S from the
\ workspace and leave the result in A,B. A is m.s.
\ The result can be used by dstl,
MACRO DS-,       ( double D single S -- ) ( -- reg A, reg B )
    0 ldc,
    OVER ldl, ldl, ldiff,         ( -- A l.s. , B m.s. )
    rev,
    1+ ldl,   rev, diff,         \ Subtract from m.s. word, expecting no overflow
END-MACRO

\ Divide double number in reg A (m.s) B (l.s.) by P from the workspace
\ and leave the remainder in reg A
\ tested
MACRO lrem,           ( reg A, reg B, -- reg A )  ( wword P -- )
    DUP ldl,  rem,              \ Get rid of multiples of P in m.s. part
    rev,  ( P) ldl, ldiv,       \ No overflow to fear
    Temp stl,                   \ Leave remainder on top
END-MACRO

\ Wait LEN milliseconds. Somewhat inaccurate for a low level process
MACRO ms,       ( int LEN -- )
    ldc,     1000 ldc, mul,
    ldpri, 63 ldc, mul, 1 adc,  \ Result 1 for high, 64 for low )
    div,                        \ Adjust count
    ldtimer, sum, tin,
END-MACRO

\ Fetches a word to reg A from ``h'' indexed with ``i''
\ tested
MACRO [],   ( HARRAY h, WWORD i -- )
    ldl, ldl, wsub,    0 ldnl,
END-MACRO

\ Stores a word from reg A to ``h'' indexed with ``i''
\ tested
MACRO []:=,   ( HARRAY h, WWORD i -- )
    ldl, ldl, wsub,    0 stnl,
END-MACRO


\ Fetches a word to reg A from ``w'' and then `i' words farther
\ tested
MACRO W[],   ( WWORD w, WWORD i -- )
    ldl, ldlp, wsub,    0 ldnl,
END-MACRO

\ Stores a word from reg A to ``w'' and then `i' words farther
\ tested
MACRO W[]:=,   ( WWORD w, WWORD i -- )
    ldl, ldlp, wsub,    0 stnl,
END-MACRO

\ ******************* code optimisation ***************************

ALSO ASSEMBLER
DEFINITIONS
\ If the address at OLDHERE contains superfluous prefixes ( $20)
\ Move the code down to remove those prefixes
\ It is no problem if the code contains constructs ( if, ..) or
\ refers to absolute addresses or workspace addresses.
\ call, and *ldpi, spell problems
\ Also an intervening repeat, if you use dirty constructs
: REMOVE-PREFIXES       ( c-addr OLDHERE -- )
    LOCAL OLDHERE
    BEGIN
        OLDHERE C@ $20 = WHILE
        OLDHERE 1+   OLDHERE   HERE OLDHERE - CMOVE
        -1 ALLOT
    REPEAT
;

:  THEN,
    DUP THEN, REMOVE-PREFIXES
;

ONLY FORTH DEFINITIONS
