\ COPYRIGHT 1992@1997 DUTCH FORTH WORKSHOP - FILENAME : LOGTWINC.FRT #1

NEEDS    -twinmisc
REVISION -logtwinc " 1.0B --- logtwinc : trouble with NEEDS solved ---"
PRIVATES
\ Append the string S to the file with name FILENAME
: APPEND-TO-FILE ( string S, string FILENAME -- )
    W/O OPEN-FILE THROW
    LOCAL HANDLE
    HANDLE FILE-SIZE THROW
    HANDLE REPOSITION-FILE THROW
    ( S) HANDLE WRITE-LINE THROW
    HANDLE CLOSE-FILE THROW
; PRIVATE

\ Auxiliar definition to see some structure in those large numbers
\ Convert the double to a string S
: (DP.)  ( double D -- string S )
    <#
        6 0 DO # LOOP [CHAR] , HOLD
        2DUP 1000000. D> IF
            6 0 DO # LOOP [CHAR] , HOLD
        THEN
        #S
    #>
;

: DP.
        (DP.)
        16 OVER - 0 MAX SPACES
        TYPE SPACE
;


\ Writes to disk the results in a free format:
\ the checksum is simply the sum of the foregoing numbers.
\ start of range, end of range, number of twins, checksum.
\ If the range started at N-SKIP (the numbers to be skipped)
\ take care not to include TWINS-SKIPPED in the count!
CREATE BUFFER PRIVATE    80 ALLOT
: WRITE-RESULT  ( double D1, D2, double N -- )
    DLOCAL #TWINS
    DLOCAL HIGH
    DLOCAL LOW

    0 0 BUFFER $!
    LOW    (DP.) BUFFER $+!  BL BUFFER $+C!
    HIGH   (DP.) BUFFER $+!  BL BUFFER $+C!
    #TWINS (DP.)  BUFFER $+!  BL BUFFER $+C!
    LOW HIGH #TWINS  D+ D+ (D.) BUFFER $+!

    BUFFER $@     S" RESULT.TXT"
    CHECK-SIEVE-CRC 0= IF HIGH 1G-SCALE 1006 TWIN-ERROR EXIT THEN
    ['] APPEND-TO-FILE CATCH IF HIGH 1G-SCALE 1005 TWIN-ERROR THEN
;

VARIABLE RESULT-FILE-HANDLE PRIVATE
CREATE RESULT-FILE-BUFFER 256 ALLOT PRIVATE
\ Open the result file and remember the file handle here.
: OPEN-RESULT-RO  ( -- )
    S" RESULT.TXT" R/O OPEN-FILE THROW
    RESULT-FILE-HANDLE !
;

\ Read a line from the result file
: READ-RESULT-RO ( -- string S, int EOF )
    RESULT-FILE-BUFFER DUP 256
    RESULT-FILE-HANDLE @ READ-LINE THROW
    >R 2DUP CHARS + [CHAR] , SWAP C! 1+ R>
;

\ Close the result file and remember the file handle here.
: CLOSE-RESULT-RO ( FH -- )
    RESULT-FILE-HANDLE @ CLOSE-FILE THROW
;

\ DEBUG [IF] OPEN-RESULT-RO READ-RESULT-RO DROP TYPE CLOSE-RESULT-RO [THEN]

DEPRIVE
                ( end of logtwinc.frt)
