
\ COPYRIGHT 1993 DUTCH FORTH WORKSHOP - FILENAME : TFBOOT.INC #0
\
\  LANGUAGE    : ANS Forth / Assembler
\  PROJECT     : tForth
\  DESCRIPTION : startup with Forth servers
\  CATEGORY    : Meta source file
\  AUTHOR      : Marcel Hendrix, December '90
\  LAST CHANGE : 930316 FCR0043 AUTO uppercasing of assembler words (if, etc.)
\  LAST CHANGE : 930124 AH Proper physical file format
\  LAST CHANGE : November 7, 1992, Marcel Hendrix, tForth assembler
\  LAST CHANGE : October 31, 1991, Marcel Hendrix, ELSE-D, in TID
\  LAST CHANGE : October 5, 1991, Marcel Hendrix
\ )
\ Protocol : here   there
\            TID   >
\                  < size
\                  < load address
\                  < start address (no more memstart )

  1 =: OLD_IPTR
  2 =: OLD_WDESC

  3 =: 'bootinp                 -- link we booted from
  4 =: 'boot                            -- store load address of uploaded code
  5 =: 'size                            -- store size of uploaded code
  6 =: 'entrypoint
  7 =: tid

  7 =: 'Link3Input      3 =: 'Link3Output
  6 =: 'Link2Input      2 =: 'Link2Output
  5 =: 'Link1Input      1 =: 'Link1Output
  4 =: 'Link0Input      0 =: 'Link0Output

  8 =: 'Event

  9 =: 'TptrLoc0
#10 =: 'TptrLoc1


                #10 ajw,                \ In a booter, WsPtr at END of program!

                OLD_IPTR  stl,          \ pop A (Iptr)
                OLD_WDESC stl,          \ pop B (Wdesc)
                'bootinp  stl,          \ Save boot input link address

                mint, sthf,
                mint, stlf,             \ store queue registers

                mint, mint, 'Link0Output stnl,  \ note that a loop ( lend )
                mint, mint, 'Link1Output stnl,  \ or ELSE, can be descheduled!
                mint, mint, 'Link2Output stnl,
                mint, mint, 'Link3Output stnl,
                mint, mint, 'Link0Input  stnl,
                mint, mint, 'Link1Input  stnl,
                mint, mint, 'Link2Input  stnl,
                mint, mint, 'Link3Input  stnl,  \ reset link channels
                mint, mint, 'Event       stnl,  \ reset event
                mint, mint, 'TptrLoc0    stnl,  \ store timer queue registers
                mint, mint, 'TptrLoc1    stnl,

                testerr,  clrhalterr,   \ reset error flag

-- Get our TID
-- NOTE THAT ELSE, can be descheduled.

          1 ldc, bcnt, tid stl,
          tid ldl,
          2 ldc, >, IF,  ( 32 bit Transputer)
                          0 ldc, 1 ldc, 1 ldc,
                          lddevid, rev,
                             IF, rev,
                                  1 eqc, IF,   5 ldc, tid stl, ( T414/425)
                                       ELSE-D, 9 ldc, tid stl, ( T805)
                                      ENDIF,
                           ELSE-D, 8 ldc, tid stl, ( T800)
                          ENDIF,
                 ENDIF,


-- Only if we're floating

                tid ldl, 7 ldc, >, IF,
                                         fptesterr,
                                ENDIF,

                0 ldc,  sttimer,        \ start timer


-- tell server our TID size

                'bootinp ldl,  $10 ldc,  xor,
                tid ldl, outbyte,


-- load the main code file

                'size    ldlp,          \ accept size and load address via link
                'bootinp ldl,
                1 ldc, bcnt,  in,

                'boot    ldlp,
                'bootinp ldl,
                1 ldc, bcnt,  in,

                'entrypoint ldlp,        \ accept entrypoint location via link
                'bootinp ldl,
                1 ldc, bcnt,  in,

                'boot    ldl,           \ target address
                'bootinp ldl,           \ channel
                'size    ldl,  in,

                'bootinp   ldl,         \ Pass channel address
                'boot      ldl,
                'entrypoint ldl,         \ and workspace
                 gcall,


                                (* End Booter *)
